// Application Design

_ace.App.design = {};

$(window).resize(function(){
	_ace.App.design.update();
	clearTimeout(_ace.resizeEndTimeout);
	_ace.resizeEndTimeout = setTimeout('_ace.App.design.update()',100);
});
_ace.App.design.update = function(){
	_ace.App.design.setParentElementToWindowSize();
	_ace.App.design.setMiddleAreaHeight();
	_ace.App.design.setMainViewWidth();
	_ace.App.design.setLeftSideNavigationMiddleHeight();
	_ace.App.design.setRightSideNavigationMiddleHeight();
}
_ace.App.design.setParentElementToWindowSize = function(){
	_ace.App.parentElement.height($(window).height());
	_ace.App.parentElement.width($(window).width());
}
_ace.App.design.setMiddleAreaHeight = function(){
	if(_ace.GeneralFunctions.ElementExists($('.MiddleArea'))){
		_ace.App.design.topNavigationHeight = _ace.GeneralFunctions.ElementExists($('.TopNavigation')) ? $('.TopNavigation').outerHeight() : 0;
		_ace.App.design.bottomNavigationHeight = _ace.GeneralFunctions.ElementExists($('.BottomNavigation')) ? $('.BottomNavigation').outerHeight() : 0;
		var height = _ace.App.parentElement.height() - _ace.App.design.topNavigationHeight - _ace.App.design.bottomNavigationHeight;
		$('.MiddleArea').height(height);
	}
}
_ace.App.design.setMainViewWidth = function(){
	if(_ace.GeneralFunctions.ElementExists($('.MainView'))){
		var LeftSideNavigation = _ace.GeneralFunctions.ElementExists($('.LeftSideNavigation')) ? $('.LeftSideNavigation').outerWidth() : 0;
		var RightSideNavigation = _ace.GeneralFunctions.ElementExists($('.RightSideNavigation')) ? $('.RightSideNavigation').outerWidth() : 0;
		var width = _ace.App.parentElement.width() - LeftSideNavigation - RightSideNavigation;
		$('.MainView').width(width);
	}
}

_ace.App.design.setLeftSideNavigationMiddleHeight = function(){
	if(_ace.GeneralFunctions.ElementExists($('.LeftSideNavigationMiddle'))){
		var LeftSideNavigationTopHeight = _ace.GeneralFunctions.ElementExists($('.LeftSideNavigationTop')) ? $('.LeftSideNavigationTop').outerHeight() : 0;
		var LeftSideNavigationBottomHeight = _ace.GeneralFunctions.ElementExists($('.LeftSideNavigationBottom')) ? $('.LeftSideNavigationBottom').outerHeight() : 0;
		var LeftSideNavigationHeight = _ace.GeneralFunctions.ElementExists($('.LeftSideNavigation')) ? $('.LeftSideNavigation').outerHeight() : 0;
		var height = LeftSideNavigationHeight - LeftSideNavigationTopHeight - LeftSideNavigationBottomHeight;
		$('.LeftSideNavigationMiddle').height(height);
	}
}

_ace.App.design.setRightSideNavigationMiddleHeight = function(){
	if(_ace.GeneralFunctions.ElementExists($('.RightSideNavigationMiddle'))){
		var RightSideNavigationTopHeight = _ace.GeneralFunctions.ElementExists($('.RightSideNavigationTop')) ? $('.RightSideNavigationTop').outerHeight() : 0;
		var RightSideNavigationBottomHeight = _ace.GeneralFunctions.ElementExists($('.RightSideNavigationBottom')) ? $('.RightSideNavigationBottom').outerHeight() : 0;
		var RightSideNavigationHeight = _ace.GeneralFunctions.ElementExists($('.RightSideNavigation')) ? $('.RightSideNavigation').outerHeight() : 0;
		var height = RightSideNavigationHeight - RightSideNavigationTopHeight - RightSideNavigationBottomHeight;
		$('.RightSideNavigationMiddle').height(height);
	}
}
