/* 
	-----------------------------------------------------------------

	By Ola Persson
	ola@kongotec.com
	www.kongotec.com
	www.olapersson.com
	
	Important: Required part.
	
	App Description: 
	Main application engine, always init first.

	-----------------------------------------------------------------
*/

$(window).load(function() {
    _ace.App.init();
});

var _ace = {};

_ace.App = {};
_ace.App.parentElement = null;

_ace.App.awakeFunctionArray = [];
_ace.App.init = function(){
	_ace.App.setParentElement();
	_ace.App.scrollBarWidth = 15;// scrollbarWidth();
	var html = _ace.App.CreateHtml();
	_ace.App.parentElement.html(html);
	_ace.App.design.update();
	_ace.projectManagement.createNew("New Project", 16);
	for(var i=0; i < _ace.App.awakeFunctionArray.length; i++){
		_ace.App.awakeFunctionArray[i]();
	}
	window.onbeforeunload = _ace.App.confirmOnPageExit;
};

_ace.App.setParentElement = function(){
	if(!_ace.GeneralFunctions.ElementExists($("#Application"))){
		var html = '<div id="Application" class="ApplicationContainer"></div>';
		$("body").append(html);
	}
	_ace.App.parentElement = $("#Application");
	_ace.App.design.setParentElementToWindowSize();
}

_ace.App.confirmOnPageExit = function (e) {
    e = e || window.event;
    var message = 'Are you sure you want to leave this page?';
    if (e) 
    {
        e.returnValue = message;
    }
    return message;
};

_ace.App.CreateHtml = function(){
	var html = "";
	html += _ace.App.create.topNavigation();
	html += '<div class="MiddleArea" id="MiddleArea">';
	html += _ace.App.create.leftSideNavigation();
	html += _ace.App.create.rightSideNavigation();
	html += _ace.App.create.mainView();
	html += '</div>';
	html += _ace.App.create.bottomNavigation();
	html += _ace.App.create.addLastHtml();
	return html;
}

// Create Html 

_ace.App.create = {};
_ace.App.create.topNavigationHtmlFunctionArray = [];
_ace.App.create.topNavigation = function(){
	var html = '';
	html += '<div class="TopNavigation" id="TopNavigation">';
	for(var i=0; i < _ace.App.create.topNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.topNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};
_ace.App.create.mainViewHtmlFunctionArray = [];
_ace.App.create.mainView = function(){
	var html = '';
	html += '<div class="MainView" id="MainView">';
	for(var i=0; i < _ace.App.create.mainViewHtmlFunctionArray.length; i++){
		html += _ace.App.create.mainViewHtmlFunctionArray[i]();
	}
	html += '</div>';
	return html;
};
_ace.App.create.bottomNavigationHtmlFunctionArray = [];
_ace.App.create.bottomNavigation = function(){
	var html = '';
	html += '<div class="BottomNavigation" id="BottomNavigation">';
	for(var i=0; i < _ace.App.create.bottomNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.bottomNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};
_ace.App.create.leftSideNavigation = function(){
	var html = '';
	html += '<div class="LeftSideNavigation" id="LeftSideNavigation">';
	html += _ace.App.create.leftSideTopNavigation();
	html += _ace.App.create.leftSideMiddleNavigation();
	html += _ace.App.create.leftSideBottomNavigation();
	html += "</div>";
	return html;
};
_ace.App.create.leftSideTopNavigationHtmlFunctionArray = [];
_ace.App.create.leftSideTopNavigation = function(){
	var html = '';
	html += '<div class="LeftSideNavigationTop" id="LeftSideNavigationTop">';
	for(var i=0; i < _ace.App.create.leftSideTopNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.leftSideTopNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};
_ace.App.create.leftSideMiddleNavigationHtmlFunctionArray = [];
_ace.App.create.leftSideMiddleNavigation = function(){
	var html = '';
	html += '<div class="LeftSideNavigationMiddle" id="LeftSideNavigationMiddle">';
	for(var i=0; i < _ace.App.create.leftSideMiddleNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.leftSideMiddleNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};
_ace.App.create.leftSideBottomNavigationHtmlFunctionArray = [];
_ace.App.create.leftSideBottomNavigation = function(){
	var html = '';
	html += '<div class="LeftSideNavigationBottom" id="LeftSideNavigationBottom">';
	for(var i=0; i < _ace.App.create.leftSideBottomNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.leftSideBottomNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};

_ace.App.create.rightSideNavigation = function(){
	var html = '';
	html += '<div class="RightSideNavigation" id="RightSideNavigation">';
	html += _ace.App.create.rightSideTopNavigation();
	html += _ace.App.create.rightSideMiddleNavigation();
	html += _ace.App.create.rightSideBottomNavigation();
	html += "</div>";
	return html;
};
_ace.App.create.rightSideTopNavigationHtmlFunctionArray = [];
_ace.App.create.rightSideTopNavigation = function(){
	var html = '';
	html += '<div class="RightSideNavigationTop" id="RightSideNavigationTop">';
	for(var i=0; i < _ace.App.create.rightSideTopNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.rightSideTopNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};
_ace.App.create.rightSideMiddleNavigationHtmlFunctionArray = [];
_ace.App.create.rightSideMiddleNavigation = function(){
	var html = '';
	html += '<div class="RightSideNavigationMiddle" id="RightSideNavigationMiddle">';
	for(var i=0; i < _ace.App.create.rightSideMiddleNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.rightSideMiddleNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};
_ace.App.create.rightSideBottomNavigationHtmlFunctionArray = [];
_ace.App.create.rightSideBottomNavigation = function(){
	var html = '';
	html += '<div class="RightSideNavigationBottom" id="RightSideNavigationBottom">';
	for(var i=0; i < _ace.App.create.rightSideBottomNavigationHtmlFunctionArray.length; i++){
		html += _ace.App.create.rightSideBottomNavigationHtmlFunctionArray[i]();
	}
	html += "</div>";
	return html;
};

_ace.App.create.addLastHtmlFunctionArray = [];
_ace.App.create.addLastHtml = function(){
	var html = '';
	for(var i=0; i < _ace.App.create.addLastHtmlFunctionArray.length; i++){
		html += _ace.App.create.addLastHtmlFunctionArray[i]();
	}
	return html;
};






