/* 
	-----------------------------------------------------------------

	A Tile Map Editor 2
	By Ola Persson
	ola@kongotec.com
	www.kongotec.com
	
	Preference Inspector Description: 
	Manage And Set Variables
	
	-----------------------------------------------------------------
*/

_ace.preferenceInspector = {};
_ace.preferenceInspector.currentObjectToEdit = null;

_ace.preferenceInspector.preferenceInspectorHtml = function(){
	var html = '';
	html += '<div id="preferenceInspector" class="preferenceInspector">';
	html += '</div>';
	return html;
	return "";
}

_ace.App.create.rightSideMiddleNavigationHtmlFunctionArray.push(_ace.preferenceInspector.preferenceInspectorHtml);

_ace.preferenceInspector.drawCurrentObject = function(){
	$('.TilePaletteWindow').remove();
	var levelIndex;
	var layerIndex;
	var layerObject = null;
	switch(_ace.levelOrganizer.currentlySelected.constructor){
		case String:
			layerObject = _ace.currentProject;
		break;
		case Array:
		switch(_ace.levelOrganizer.currentlySelected.length){
			case 0:
				$("#preferenceInspector").html("");
				return;
			break;
			case 1: 
				levelIndex = _ace.levelOrganizer.currentlySelected[0];
				layerObject = _ace.currentProject.arrayOfLevels[levelIndex];
			break;
			case 2:
				levelIndex = _ace.levelOrganizer.currentlySelected[0];
				layerIndex = _ace.levelOrganizer.currentlySelected[1];
				layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
			break;
		}
		break;
	}
	_ace.preferenceInspector.currentObjectToEdit = layerObject;
	var html = "<ul>";
	html += _ace.preferenceInspector.htmlFromObject(layerObject);
	html += "</ul>";
	$("#preferenceInspector").html(html);
	
	$(".LoadImage").click(function( event ){
		var TheUrlElement = $(this).prev();
		_ace.resourceManagement.loadImage($(TheUrlElement).val());
	});
	
	$(".ToggleOptions").click(function( event ){
		var TheElementToToggle = $(this).prev();
		$( TheElementToToggle ).toggle( "blind", 250 );
	});
	
	$(".ToggleOptions").prev().hide();
	
	$( ".PreferenceInput" ).keyup(function() {
		$(this).change();
	});
	
	$( ".PreferenceInput" ).change(function() {
		_ace.preferenceInspector.updatePreference(this);
	});
	
	$( ".BooleanPreferenceInput" ).change(function() {
		_ace.preferenceInspector.updateBooleanPreference(this);
	});

	$( ".AnimationStylesSelector" ).change(function() {
		_ace.preferenceInspector.updatePreference(this);
	});
	
	$( ".FontSelector" ).change(function() {
		_ace.preferenceInspector.changeFont(this);
	});
	
	$( ".AnimateInAndOutPresetSelector" ).change(function() {
		_ace.preferenceInspector.changeAnimationInAndOutPreset(this);
	});
	
	$( ".AnimateInPresetSelector" ).change(function() {
		_ace.preferenceInspector.changeAnimationInPreset(this);
	});
	
	$( ".AnimateOutPresetSelector" ).change(function() {
		_ace.preferenceInspector.changeAnimationOutPreset(this);
	});

	$( ".TileSetSelector" ).change(function() {
		_ace.preferenceInspector.updatePreference(this);
	});

	$( ".TilePaletteWindow" ).draggable({ handle: ".DragHandle" });
	$( ".TilePaletteWindow" ).mousedown(function( event ){
		$( ".TilePaletteWindow" ).removeClass( "TopTilePaletteWindow" );
		$(this).addClass( "TopTilePaletteWindow" );
	});

 	$(".HideThisTilePaletteWindow").click(function( event ){
 		$(this).parent().hide();
 	});

	$(".ClickToSelectTile").click(function( event ){
		var parentOffset = $(this).offset();
		var positionWithinElement = {
			top : event.pageY - parentOffset.top,
			left :  event.pageX - parentOffset.left
		};
		_ace.preferenceInspector.tilePalette.click(this, positionWithinElement);
	});
	
	var imageDropAreaId;
	
	$(".ImageDropArea").each(function( index ) {
	  	imageDropAreaId = $( this ).attr('id');
		_ace.preferenceInspector.imageSelector.update(imageDropAreaId);
		_diu.turnElementByIdIntoDropArea(imageDropAreaId);
	});

	_ace.preferenceInspector.colorSelector.bind();
	_ace.preferenceInspector.imageSelector.bindFold();
	
	_ace.preferenceInspector.addButtonsToTileSetsInProjectList();
	
	$( ".OutputFormatList" ).change(function() {
		_ace.createOutPutCanvasContainer();
	});
	
}

_ace.preferenceInspector.htmlFromObject = function(theObject, oldKey){
	if(! oldKey){
		oldKey = ""; 
	} else {
		oldKey += "-"; 
	}
	var html = "";
	$.each(theObject, function( key, value ) {
		if(
			// key == "layerName" ||
			key == "INTEGER_selectedTileSet" ||
			key == "INTEGER_selectedTile" ||
			key == "resources"
			
		){
			return "";
		}
		if(value != null){
			switch (value.constructor) {
				case String : 
				case Number : 
					
					switch(key){
						case "STRING_objectType" :
							html += '<li><span class="LayerType">' + _ace.GeneralFunctions.consvertToDisplayText(value) + '</span></li>';
						break;
						case "STRING_tileSetIdentifyer" : 
						
							var startPosition = {
								left: $(window).width() - 400,
								top: 60
							}
							
							var tileSetIndex = oldKey.split("-");
							tileSetIndex = tileSetIndex[tileSetIndex.length-2];
														
							if(!isNaN(tileSetIndex)){
								tileSetIndex = parseInt(tileSetIndex,10);
								startPosition.left += 20 * tileSetIndex;
								startPosition.top += 35 * tileSetIndex;
							}
							
							var tileSetName;
							
							for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
								
								selected = "";
								
								if(
									_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == value
								){
									tileSetName = _ace.currentProject.tileSets[i].STRING_tileSetName;
								}
							}
							var paletteContainerHtml = '';
							paletteContainerHtml += '<div class="TilePaletteWindow" id="'+oldKey+key+'_TilePaletteWindow" style="top:'+startPosition.top+'px; left:'+startPosition.left+'px;">';
							paletteContainerHtml += '<span class="PreferenceObjectHeader DragHandle">' + tileSetName + '</span>';
							paletteContainerHtml += '<div class="TilePaletteWindowBody">';
							paletteContainerHtml += '<div class="TilePaletteContainer">';
							paletteContainerHtml += '<canvas class="TilePaletteCanvas"></canvas>';
							paletteContainerHtml += '</div>';
							paletteContainerHtml += '</div>';
							paletteContainerHtml += '</div>';	
							$('body').append(paletteContainerHtml);
							_ace.preferenceInspector.tilePalette.drawPalette(oldKey+key);
						break;
						case "STRING_imgIdentifyer" :
							html += '<li>';
							html += _ace.preferenceInspector.imageSelector.html(oldKey+key);
							html += '</li>';
						break;
						case "STRING_textString" :
							html += '<li><span class="PreferenceHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key) + '</span>';
							html += '<textarea rows="4" cols="50" class="PreferenceInput" id="'+oldKey+key+'" name="'+oldKey+key+'">';
							html += value;
							html += '</textarea>';
							html += '</li>';
						break;
						default : 
							html += '<li><span class="PreferenceHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key) + '</span><input class="PreferenceInput" id="'+oldKey+key+'" name="'+oldKey+key+'" type="text" value="' + value+'"></li>';
						break;
					}
				break;
				case Boolean : 
					var checked = value ? " checked " : "";
					html += '<li>';
					html += '<span class="PreferenceHeader">';
					html += '<input class="BooleanPreferenceInput" type="checkbox" id="'+oldKey+key+'" name="'+oldKey+key+'" '+checked+'>';
					html += '<label for="'+oldKey+key+'">'+_ace.GeneralFunctions.consvertToDisplayText(key)+'</label>';
					html += '</span>';
					html += '</li>';
				break;
				case Array : 
				switch(key){
				case "tileSets" :
					html += '<li><ul class="PreferenceObject OutputFormatList">';
					html += '<li><span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key);
					html += '</span>' + _ace.preferenceInspector.htmlFromObject(value, oldKey+key) + '</li>';
					html += '</ul></li>';
					html += '</ul><a class="PreferenceInspectorButton" onclick="_ace.preferenceInspector.addTileSetToProject()">Add Tile Set</a></li>';
				break;
				case "ARRAY_useTileSetsWithIdentifyer" :
					
					html += '<li><ul class="PreferenceObject">';
					html += '<li><span class="PreferenceObjectHeader">Tile sets</span></li>';
					
					var tileSetName;
					var startPosition = {
						left: $(window).width() - 400,
						top: 60
					}
						
					for(var j = 0; j < value.length; j++){
						var paletteContainerHtml = '';
						paletteContainerHtml += '<div class="TilePaletteWindow" id="'+oldKey+key+"-"+j+'_TilePaletteWindow" style="top:'+startPosition.top+'px; left:'+startPosition.left+'px;">';
						startPosition.left += 20;
						startPosition.top += 35;
						paletteContainerHtml += '<span class="PreferenceObjectHeader DragHandle">' + _ace.GeneralFunctions.consvertToDisplayText("Tile set - " + j) + '<span class="CurrentTileIndex"></span></span>';
						paletteContainerHtml += '<div class="TilePaletteWindowBody">';
						paletteContainerHtml += '<select class="PreferenceSelector TileSetSelector" id="'+oldKey+key+"-"+j+'" name="'+oldKey+key+"-"+j+'">';
						var selected; 
						var tileSetName;
		
						for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
							selected = "";
							if(
								_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == value[j]
							){
								selected = " selected";
								tileSetName = _ace.currentProject.tileSets[i].STRING_tileSetName;
							}
							paletteContainerHtml += '<option value="'+_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer+'" '+selected+'>'+_ace.currentProject.tileSets[i].STRING_tileSetName+'</option>';
						}
						paletteContainerHtml += "</select>";
						
						paletteContainerHtml += '<div class="TilePaletteContainer">';
						paletteContainerHtml += '<canvas class="TilePaletteCanvas ClickToSelectTile"></canvas>';
						paletteContainerHtml += '</div>';
						paletteContainerHtml += '</div>';
						paletteContainerHtml += '<span class="HideThisTilePaletteWindow">Hide tile window</span>';
						paletteContainerHtml += '</div>';
						
						$('body').append(paletteContainerHtml);
						_ace.preferenceInspector.tilePalette.drawPalette(oldKey+key+"-"+j);
						
						html += '<li><span class="PreferenceInspectorButton ListOfTileSetsItem" id="'+oldKey+key+"-"+j+'_TilePaletteListItem" onclick="_ace.preferenceInspector.tilePalette.unhideById(\''+oldKey+key+"-"+j+'_TilePaletteWindow\')">'+(_ace.GeneralFunctions.ShortenString(j+' - '+tileSetName, 17))+'<span class="RemoveTileSetFromLayerButton" title="Remove Tile Set From Layer" onclick="_ace.preferenceInspector.removeTileSetFromLayerButton(\''+j+'\')">Remove</span></span></li>';
						
					}
					html += '</ul><a class="PreferenceInspectorButton" onclick="_ace.preferenceInspector.addTileSetToLayerButton()">Add Tile Set</a></li>';
					break;
				}
				break;
				case Object : 
					switch(key){
						case "levelPixelSize" :
							html += '<li><ul class="PreferenceObject">';
							html += '<li><span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key);
							html += '</span>' + _ace.preferenceInspector.htmlFromObject(value, oldKey+key) + '</li>';
							
							var levelIndex = _ace.levelOrganizer.currentlySelected[0];
							var levelObject = _ace.currentProject.arrayOfLevels[levelIndex];
							
							var screensWide = (levelObject.levelPixelSize.INTEGER_width / _ace.currentProject.parallaxMode.INTEGER_screenSizeWidth).toFixed(2);
							var screensHigh = (levelObject.levelPixelSize.INTEGER_height / _ace.currentProject.parallaxMode.INTEGER_screenSizeHeight).toFixed(2);
							var screenResolution = _ace.currentProject.parallaxMode.INTEGER_screenSizeWidth + " x " + _ace.currentProject.parallaxMode.INTEGER_screenSizeHeight;
							
							html += '<li><span class="PreferenceHeader" id="'+oldKey+key+'">With current '+screenResolution+' px screen resolution this level resolution will translate to '+screensWide+' x '+screensHigh+' screens.</span></li>';
							
							html += '</ul></li>';
						break;
						case "mapSize" :
							
							var levelIndex = _ace.levelOrganizer.currentlySelected[0];
							var levelObject = _ace.currentProject.arrayOfLevels[levelIndex];
							var layerIndex = _ace.levelOrganizer.currentlySelected[1];
							var layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
							
							var tileSetZero;
		
							for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
								if(_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == layerObject.ARRAY_useTileSetsWithIdentifyer[0]){
									tileSetZero = _ace.currentProject.tileSets[i];
									break;
								}
							}
							
							var recommendedWidth = (levelObject.levelPixelSize.INTEGER_width * layerObject.parallaxSpeed.FLOAT_x);
							recommendedWidth += -_ace.currentProject.parallaxMode.INTEGER_screenSizeWidth * (layerObject.parallaxSpeed.FLOAT_x - 1);
							recommendedWidth /= (tileSetZero.tilePixelSize.INTEGER_width * levelObject.FLOAT_tileZoomFactor);
							recommendedWidth = Math.ceil(recommendedWidth);
								
							var recommendedHeight = (levelObject.levelPixelSize.INTEGER_height * layerObject.parallaxSpeed.FLOAT_y); 
							recommendedHeight += -_ace.currentProject.parallaxMode.INTEGER_screenSizeHeight * (layerObject.parallaxSpeed.FLOAT_y - 1);
							recommendedHeight /= (tileSetZero.tilePixelSize.INTEGER_height * levelObject.FLOAT_tileZoomFactor);
							recommendedHeight = Math.ceil(recommendedHeight);
							
							html += '<li><ul class="PreferenceObject">';
							html += '<li><span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key) + '</span>';
							html += '<li><span class="PreferenceHeader" id="'+oldKey+key+'_RecommendedScreenSize">At this screen resolution, level pixel size, parallax speed & tile size, the recommended size is <br/>'+recommendedWidth+' x '+recommendedHeight+' tiles.</span></li>';
							
							html += '<span class="PreferenceHeader" id="'+oldKey+key+'">Current size: '+(layerObject.mapSize.INTEGER_width)+' x '+(layerObject.mapSize.INTEGER_height)+'</span>';
							html += '</li></ul>';
							html += '<ul class="LayerSizeButtonList">';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.addRow(\'top\')">+ Top</a></li>';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.addRow(\'left\')">+ Left</a></li>';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.addRow(\'right\')">+ Right</a></li>';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.addRow(\'bottom\')">+ Bottom</a></li>';
							html += '</ul>';
							html += '<ul class="LayerSizeButtonList">';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.removeRow(\'top\')">- Top</a></li>';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.removeRow(\'left\')">- Left</a></li>';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.removeRow(\'right\')">- Right</a></li>';
							html += '<li><a class="PreferenceInspectorButton" onclick=" _ace.editCurrentTileMapLayer.removeRow(\'bottom\')">- Bottom</a></li>';
							html += '</ul>';
							html += '</li>';

						break;
						case "editorSettings" :
							html += '<li><ul class="PreferenceObject">';
							html += '<li><span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key);
							html += '</span>' + _ace.preferenceInspector.htmlFromObject(value, oldKey+key) + '</li>';
							html += '</ul><a class="PreferenceInspectorButton" onclick="_ace.preferenceInspector.fillTileMapButton()">Fill Tile Map Layer</a></li>';
						break;
						case "color" : 
							html += '<li>';
							html += '<span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key) + '</span>';
							html += _ace.preferenceInspector.colorSelector.html(oldKey+key, value);
							html += '<ul class="PreferenceObject FoldableObject">';
							html += _ace.preferenceInspector.htmlFromObject(value, oldKey+key);
							html += '</ul><a class="PreferenceInspectorButton ToggleOptions">Toggle Options</a></li>';
						break; 
						case "canvasPosition" : 
							html += '<li><ul class="PreferenceObject">';
							html += '<li><span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key);
							html += '</span></li>';
							
							var checked1 = checked2 = checked3 = "";
							switch(value.FLOAT_x){
								case 0: 
									checked1 = " checked ";
								break;
								case 0.5: 
									checked2 = " checked ";
								break;
								case 1: 
									checked3 = " checked ";
								break;
							}
							html += '<li>';
							html += '<form class="RadioButtonRow">';
							html += '<input class="PreferenceInput" type="radio" id="'+key+'-FLOAT_x-1" name="'+key+'-FLOAT_x" value="0.0"'+checked1+'>';
							html += '<label for="'+key+'-FLOAT_x-1">Left</label>';
							html += '<input class="PreferenceInput" type="radio" id="'+key+'-FLOAT_x-2" name="'+key+'-FLOAT_x" value="0.5"'+checked2+'>';
							html += '<label for="'+key+'-FLOAT_x-2">Center</label>';
							html += '<input class="PreferenceInput" type="radio" id="'+key+'-FLOAT_x-3" name="'+key+'-FLOAT_x" value="1.0"'+checked3+'>';
							html += '<label for="'+key+'-FLOAT_x-3">Right</label>';
							html += '</form>';
							html += '</li>';

							checked1 = checked2 = checked3 = "";
							switch(value.FLOAT_y){
								case 0: 
									checked1 = " checked ";
								break;
								case 0.5: 
									checked2 = " checked ";
								break;
								case 1: 
									checked3 = " checked ";
								break;
							}
							
							html += '<li>';
							html += '<form class="RadioButtonRow">';
							html += '<input class="PreferenceInput" type="radio" id="'+key+'-FLOAT_y-1" name="'+key+'-FLOAT_y" value="0.0"'+checked1+'>';
							html += '<label for="'+key+'-FLOAT_y-1">Top</label>';
							html += '<input class="PreferenceInput" type="radio" id="'+key+'-FLOAT_y-2" name="'+key+'-FLOAT_y" value="0.5"'+checked2+'>';
							html += '<label for="'+key+'-FLOAT_y-2">Middle</label>';
							html += '<input class="PreferenceInput" type="radio" id="'+key+'-FLOAT_y-3" name="'+key+'-FLOAT_y" value="1.0"'+checked3+'>';
							html += '<label for="'+key+'-FLOAT_y-3">Bottom</label>';
							html += '</form>';
							html += '</li>';
							html += '</ul></li>';
						break;
						default : 
							html += '<li><ul class="PreferenceObject">';
							html += '<li><span class="PreferenceObjectHeader">' + _ace.GeneralFunctions.consvertToDisplayText(key);
							html += '</span>' + _ace.preferenceInspector.htmlFromObject(value, oldKey+key) + '</li>';
							html += '</ul></li>';
						break;
					}
				break;
			}
		}
	});
	return html;
}

_ace.preferenceInspector.updateHtmlFromObject = function(theObject, oldKey){
	if(! oldKey){
		oldKey = ""; 
	} else {
		oldKey += "-"; 
	}
	$.each(theObject, function( key, value ) {
		if(
			key == "layerName" ||
			key == "textAlign" ||
			key == "style" ||
			key == "origin"
		){
			return;
		}
		if(value != null){
			switch (value.constructor) {
				case String : 
				case Number : 
					switch(key){
						case "STRING_objectType" :
						break;
						case "STRING_tileSetName" :
							var tilePaletteWindowId = oldKey+"STRING_tileSetIdentifyer_TilePaletteWindow";
							$("#"+tilePaletteWindowId).find(".PreferenceObjectHeader").html(theObject.STRING_tileSetName);
						break;
						case "STRING_imgIdentifyer" :
							_ace.preferenceInspector.imageSelector.update(oldKey+key);
						break;
						default : 
							$("#"+oldKey+key).val(value);
						break;
					}
				break;
				case Boolean : 
					$("#"+oldKey+key).prop('checked', value);
				break;
				case Array : 
				switch(key){
					case "tileSets" :
						_ace.preferenceInspector.updateHtmlFromObject(value, oldKey+key);
					break;
					case "ARRAY_useTileSetsWithIdentifyer" :
						for(var j = 0; j < value.length; j++){
							for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
								if(
									_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == value[j]
								){
									var html = (_ace.GeneralFunctions.ShortenString(j+' - '+_ace.currentProject.tileSets[i].STRING_tileSetName, 17))+'<span class="RemoveTileSetFromLayerButton" title="Remove Tile Set From Layer" onclick="_ace.preferenceInspector.removeTileSetFromLayerButton(\''+j+'\')">Remove</span>';
							
									$("#"+oldKey+key+"-"+j+'_TilePaletteListItem').html(html);
									break;
								}
							}
						}
					break;
				}
				break;
				case Object : 
					switch(key){
						case "levelPixelSize" :
							var levelIndex = _ace.levelOrganizer.currentlySelected[0];
							var levelObject = _ace.currentProject.arrayOfLevels[levelIndex];
							var screensWide = (levelObject.levelPixelSize.INTEGER_width / _ace.currentProject.parallaxMode.INTEGER_screenSizeWidth).toFixed(2);
							var screensHigh = (levelObject.levelPixelSize.INTEGER_height / _ace.currentProject.parallaxMode.INTEGER_screenSizeHeight).toFixed(2);
							var screenResolution = _ace.currentProject.parallaxMode.INTEGER_screenSizeWidth + " x " + _ace.currentProject.parallaxMode.INTEGER_screenSizeHeight;					
							var html = 'With current '+screenResolution+' px screen resolution this level resolution will translate to '+screensWide+' x '+screensHigh+' screens.';
							$("#"+oldKey+key).html(html);
						break;
						case "mapSize" :
							var levelIndex = _ace.levelOrganizer.currentlySelected[0];
							var levelObject = _ace.currentProject.arrayOfLevels[levelIndex];
							var layerIndex = _ace.levelOrganizer.currentlySelected[1];
							var layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
							var tileSetZero;
							for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
								if(_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == layerObject.ARRAY_useTileSetsWithIdentifyer[0]){
									tileSetZero = _ace.currentProject.tileSets[i];
									break;
								}
							}
							var recommendedWidth = (levelObject.levelPixelSize.INTEGER_width * layerObject.parallaxSpeed.FLOAT_x);
							recommendedWidth += -_ace.currentProject.parallaxMode.INTEGER_screenSizeWidth * (layerObject.parallaxSpeed.FLOAT_x - 1);
							recommendedWidth /= tileSetZero.tilePixelSize.INTEGER_width * levelObject.FLOAT_tileZoomFactor;
							recommendedWidth = Math.ceil(recommendedWidth);
							var recommendedHeight = (levelObject.levelPixelSize.INTEGER_height * layerObject.parallaxSpeed.FLOAT_y); 
							recommendedHeight += -_ace.currentProject.parallaxMode.INTEGER_screenSizeHeight * (layerObject.parallaxSpeed.FLOAT_y - 1);
							recommendedHeight /= tileSetZero.tilePixelSize.INTEGER_height * levelObject.FLOAT_tileZoomFactor;
							recommendedHeight = Math.ceil(recommendedHeight);
							var html;
							html = 'At this screen resolution, level pixel size, parallax speed & tile size, the recommended size is <br/>'+recommendedWidth+' x '+recommendedHeight+' tiles.';
							$("#"+oldKey+key+'_RecommendedScreenSize').html(html);
							html = 'Current size: '+(layerObject.mapSize.INTEGER_width)+' x '+(layerObject.mapSize.INTEGER_height);
							$("#"+oldKey+key).html(html);
						break;
						case "color" : 
							var theColorAsString = _ace.GeneralFunctions.colorRgbObjectToRgbString(value);
							$("#"+oldKey+key).css({'background-color' : theColorAsString});
							_ace.preferenceInspector.updateHtmlFromObject(value, oldKey+key);
						break; 
						default : 
							_ace.preferenceInspector.updateHtmlFromObject(value, oldKey+key);
						break;
					}
				break;
			}
		}
	});
}

_ace.preferenceInspector.updateCurrentObjectToEdit = function(theObjectKey, theValue){
	theObjectKey = theObjectKey.split("-");
	switch(theObjectKey.length){
		case 1 : 
		_ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]] = theValue;
		break; 
		case 2 :
		_ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]] = theValue;
		break;
		case 3 :
		_ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]] = theValue;
		break;
		case 4 :
		_ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]] = theValue;
		break;
		case 5 :
		_ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]] = theValue;
		break;
		case 6 :
		_ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]][theObjectKey[5]] = theValue;
		break;
	}
	_ace.levelOrganizer.update();
	_ace.mainView.drawOutputCanvases();
	_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
	_ace.preferenceInspector.tilePalette.updateAll();
}

_ace.preferenceInspector.updatePreference = function(theUpdatedElement){
	var theObjectKey = $(theUpdatedElement).attr('name');
	var theValue = $(theUpdatedElement).val();
	var variableType = theObjectKey.split("-");
	variableType = variableType[variableType.length-1];
	variableType = variableType.split("_");
	variableType = variableType[0];
	switch(variableType){
		case "STRING" :
		
		break;
		case "FLOAT" :
			if(theValue!=""){
				if(theValue.substr(theValue.length - 1) != "." && isNaN(theValue)==false){
					theValue = parseFloat(theValue,10);
				}
			} else {
				theValue = 0;
			}
		break;
		case "INTEGER" :
			theValue = parseInt(theValue,10);
		break;
		case "BOOLEAN" :
			if(theValue == "true" || theValue == "false"){
				theValue = theValue == "true";
			}
		break;
		case "HTMLIMAGE" :
		default :

		break;
	}
	_ace.preferenceInspector.updateCurrentObjectToEdit(theObjectKey, theValue);
}

_ace.preferenceInspector.updateBooleanPreference = function(theUpdatedElement){	
	var theObjectKey = $(theUpdatedElement).attr('name');	
	var theValue = $(theUpdatedElement).prop("checked");
	_ace.preferenceInspector.updateCurrentObjectToEdit(theObjectKey, theValue);
}

_ace.preferenceInspector.colorSelector = {};

_ace.preferenceInspector.colorSelector.html = function(theObjectKey, rgbObject){
	var hexColor = _ace.GeneralFunctions.rgbToHex(rgbObject);
	var html = '<span class="ColorDisplay" name="'+theObjectKey+'" id="'+theObjectKey+'" style="background-color:'+hexColor+';"></span>';
	html += '<ul class="ColorSelector">';
	for(var i = 0; i<_ace.currentProject.styleSheets.colorStyleArray.length; i++){
		hexColor = _ace.GeneralFunctions.rgbToHex(_ace.currentProject.styleSheets.colorStyleArray[i]);
		html += '<li class="ColorSelectorColor" style="background-color:'+hexColor+';"></li>';
	}
	html += '</ul>';
	return html;
}

_ace.preferenceInspector.colorSelector.bind = function(){
	$(".ColorDisplay").click(function( event ){
		var TheElementToToggle = $(this).next();
		$( TheElementToToggle ).toggle( "blind", 250 );
	});
	$(".ColorDisplay").next().hide();
	$(".ColorSelectorColor").click(function( event ){
		var TheColorDisplay = $(this).parent().prev();
		var MyIndex = $(this).index();
		var TheColor = _ace.currentProject.styleSheets.colorStyleArray[MyIndex];
		TheColorAsString = _ace.GeneralFunctions.colorRgbObjectToRgbString(TheColor);
		$(TheColorDisplay).css({'background-color' : TheColorAsString});
		_ace.preferenceInspector.colorSelector.updateColor($(TheColorDisplay));
	});
}

_ace.preferenceInspector.colorSelector.updateColor = function(theUpdatedElement){
	var theObjectKey = $(theUpdatedElement).attr('name');
	var theColor = $(theUpdatedElement).css('background-color');
	theColor = _ace.GeneralFunctions.colorRgbStringToRgbObject(theColor);
	_ace.preferenceInspector.updateCurrentObjectToEdit(theObjectKey, theColor);
}

_ace.preferenceInspector.imageSelector = {};

_ace.preferenceInspector.imageSelector.html = function(id){
	var html = '';
	html += '<div class="ImageDropArea" id="'+id+'">';
	html += '<div class="ImageDropAreaPreviewContainer" id="'+id+'_ImageDropAreaPreviewContainer"></div>';
	html += '<span class="ImageDropAreaLabelContainer"><span class="ImageDropAreaLabel">Drop image here</span><span>';
	html += '</div>';
	html += '<ul class="ImageSelector" id="'+id+'_ImageSelector">';
	html += '</ul>';
	return html;
}

_ace.preferenceInspector.imageSelector.update = function(id){
	_ace.preferenceInspector.imageSelector.updateHtml(id);
	_ace.preferenceInspector.imageSelector.bindClick(id+'_ImageSelector');
	_ace.preferenceInspector.tilePalette.updateAll();
}

_ace.preferenceInspector.imageSelector.updateHtml = function(id){
	var theObjectKey = id;
	theObjectKey = theObjectKey.split("-");
	var currentObject = _ace.preferenceInspector.currentObjectToEdit;
	switch(theObjectKey.length-1){
		case 1 : 
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]];
		break; 
		case 2 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]];
		break;
		case 3 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]];
		break;
		case 4 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]];
		break;
		case 5 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]];
		break;
		case 6 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]][theObjectKey[5]];
		break;
	}
	var theImage;
	for(var i  = 0; i < _ace.currentProject.resources.images.length; i++){
			if(_ace.currentProject.resources.images[i].STRING_imgIdentifyer == currentObject.STRING_imgIdentifyer){
				theImage = _ace.currentProject.resources.images[i].HTMLIMAGE_img;
				theImage = theImage.outerHTML;
				break;
			}
	}
	$("#"+id+"_ImageDropAreaPreviewContainer").html(theImage);
	var html = "";
	for(var i  = 0; i < _ace.currentProject.resources.images.length; i++){
			theImage = _ace.currentProject.resources.images[i].HTMLIMAGE_img;
			theImage = theImage.outerHTML;
			html += '<li class="ImageDisplay" name="'+_ace.currentProject.resources.images[i].STRING_imgIdentifyer+'">'+theImage+'</li>';
	}
	$("#"+id+"_ImageSelector").html(html);
}

_ace.preferenceInspector.imageSelector.bindFold = function(){
	$(".ImageDropArea").click(function( event ){
		var TheElementToToggle = $(this).next();
		$( TheElementToToggle ).toggle( "blind", 250 );
	});
	$(".ImageDropArea").next().hide();
}

_ace.preferenceInspector.imageSelector.bindClick = function(imageSelectorId){
	$("#"+imageSelectorId).find(".ImageDisplay").click(function( event ){
		var previousElement = $(this).parent().prev();
		var theObjectKey = $(previousElement).attr('id');
		var imageSelectorElementId = theObjectKey;
		theObjectKey = theObjectKey.split("-");
		var currentObject = _ace.preferenceInspector.currentObjectToEdit;
		switch(theObjectKey.length-1){
			case 1 : 
			currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]];
			break; 
			case 2 :
			currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]];
			break;
			case 3 :
			currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]];
			break;
			case 4 :
			currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]];
			break;
			case 5 :
			currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]];
			break;
			case 6 :
			currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]][theObjectKey[5]];
			break;
		}
		currentObject.STRING_imgIdentifyer = $(this).attr('name');
		_ace.preferenceInspector.imageSelector.update(imageSelectorElementId);
	});
}

_ace.preferenceInspector.addTileSetToProject = function(){
	var objectToAdd = {
	        STRING_tileSetName: "New Tile Set",
	        STRING_tileSetIdentifyer:  Math.random().toString(36).substr(2, 9),
	        STRING_imgIdentifyer: _ace.currentProject.resources.images[0].STRING_imgIdentifyer,
	        pixelStartPosition: {
	            INTEGER_x: 0,
	            INTEGER_y: 0
	        },
	        tilePixelSize: {
	            INTEGER_width: 16,
	            INTEGER_height: 16
	        },
	        pixelSpaceBetweenTiles: {
	            INTEGER_x: 0,
	            INTEGER_y: 0
	        },
	        tileCount: {
	            INTEGER_tilesWide: 12,
	            INTEGER_tilesHigh: 8
	        },
	        tileSetEditorSettings: {
	            INTEGER_airTile: 0,
	            INTEGER_paletteTilesWide: 12,
	            pixelSpaceBetweenTiles: {
	                INTEGER_x: 1,
	                INTEGER_y: 1
	            },
	            FLOAT_paletteZoom: 1.5
	        }
	    };
	_ace.currentProject.tileSets.push(objectToAdd);
	_ace.preferenceInspector.drawCurrentObject();
}

_ace.preferenceInspector.addButtonsToTileSetsInProjectList = function(){
	var ElementsThatNeedButtons = $(".OutputFormatList").children();
	var foundObject;
	var htmlToAppend;
	ElementsThatNeedButtons.each(function( index ) {
		foundObject = $(this).find('.PreferenceObject').first();
		htmlToAppend = '';
		htmlToAppend += '<span class="DuplicateThisTileSet" onclick="_ace.preferenceInspector.duplicateTileSetInProject('+(index-1)+')" title="Duplicate This Tile Set">Duplicate This Tile Set</span>';
		htmlToAppend += '<span class="DeleteThisTileSetFromProject" onclick="_ace.preferenceInspector.deleteTileSetFromProjectButton('+(index-1)+')" title="Delete This Tile Set From Project">Delete This Tile Set From Project</span>';
		$(foundObject).append(htmlToAppend);
	});
}

_ace.preferenceInspector.duplicateTileSetInProject = function(index){
	var duplicateItem = jQuery.extend(true, {}, _ace.currentProject.tileSets[index]);
	duplicateItem.STRING_tileSetIdentifyer = Math.random().toString(36).substr(2, 9);
	duplicateItem.STRING_tileSetName = "Duplicate " + duplicateItem.STRING_tileSetName;
	_ace.currentProject.tileSets.splice(index,0,duplicateItem);
	_ace.preferenceInspector.drawCurrentObject();
}

_ace.preferenceInspector.deleteTileSetFromProjectButton = function(index){
	if(_ace.currentProject.tileSets.length==1){
		_ace.prompt({}, "","Can't delete tile set. At least one tile set is needed.");	
		return;
	}
	var tileSetToDeleteIdentifyer = _ace.currentProject.tileSets[index].STRING_tileSetIdentifyer;
	var currentTileSetIdentifyer;
	for(var i = 0; i < _ace.currentProject.arrayOfLevels.length; i++){
		for(var ii = 0; ii < _ace.currentProject.arrayOfLevels[i].arrayOfLayers.length; ii++){
			for(var iii = 0; iii < _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].ARRAY_useTileSetsWithIdentifyer.length; iii++){
				currentTileSetIdentifyer = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].ARRAY_useTileSetsWithIdentifyer[iii];
				if(currentTileSetIdentifyer == tileSetToDeleteIdentifyer){
					_ace.prompt({}, "","This tile set is still in use, remove usage from all layers before deleting.");	
					return;
				}
			}
		}
	}
	_ace.prompt({}, 
	"_ace.preferenceInspector.deleteTileSetFromProject('"+index+"')",
	"Warning! This removes the tile set from the project.");
}

_ace.preferenceInspector.deleteTileSetFromProject = function(index){
	_ace.promptCancel();
	var selectedlevelIndex = parseInt(index, 10);
	var selectedArray = _ace.currentProject.tileSets;
	var deletedItem = selectedArray.splice(selectedlevelIndex,1)[0];
	_ace.preferenceInspector.drawCurrentObject();
}

_ace.preferenceInspector.tilePalette = {};
_ace.preferenceInspector.tilePalette.updateAll = function(){
	var theId = '';
	var tilePaletteWindows = $('.TilePaletteWindow');
	$( tilePaletteWindows ).each(function( index ) {
		theId = $(this).attr('id');
		theId = theId.replace("_TilePaletteWindow", "");
		_ace.preferenceInspector.tilePalette.drawPalette(theId);
	});
}
_ace.preferenceInspector.tilePalette.drawPalette = function(id){
	var canvasElements = $("#"+id+"_TilePaletteWindow").find("canvas");
	var canvasElement = canvasElements[0];
	var canvasContext = canvasElement.getContext('2d');
	
	canvasContext.clearRect(
		0,
		0,
		canvasElement.width,
		canvasElement.height
	);
	var theObjectKey = id;
	theObjectKey = theObjectKey.split("-");
	var currentObject = _ace.preferenceInspector.currentObjectToEdit;
	switch(theObjectKey.length){
		case 1 : 
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]];
		break; 
		case 2 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]];
		break;
		case 3 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]];
		break;
		case 4 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]];
		break;
		case 5 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]];
		break;
		case 6 :
		currentObject = _ace.preferenceInspector.currentObjectToEdit[theObjectKey[0]][theObjectKey[1]][theObjectKey[2]][theObjectKey[3]][theObjectKey[4]][theObjectKey[5]];
		break;
	}
	var tileSetIdentifyer;
	tileSetIdentifyer = currentObject;
	var tileSetImage;
	var i;
	var ii;
	for(i  = 0; i < _ace.currentProject.tileSets.length; i++){
		if(_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == tileSetIdentifyer ){
			var tileSetImageIdentifyer = _ace.currentProject.tileSets[i].STRING_imgIdentifyer;
			break;
		}
	}
	for(ii  = 0; ii < _ace.currentProject.resources.images.length; ii++){
		if(_ace.currentProject.resources.images[ii].STRING_imgIdentifyer == tileSetImageIdentifyer ){
			tileSetImage = _ace.currentProject.resources.images[ii].HTMLIMAGE_img;
			break;
		}
	}
	var sourceCutOriginX = 0;
	var sourceCutOriginY = 0;
	var sourceCutWidth = 16;
	var sourceCutHeight = 16;
	var targetX = 0;
	var targetY = 0;
	var targetPasteWidth = 16;
	var targetPasteHeight = 16;
	var tileCount = _ace.currentProject.tileSets[i].tileCount.INTEGER_tilesWide * _ace.currentProject.tileSets[i].tileCount.INTEGER_tilesHigh;
	canvasElement.width = (_ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide * _ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom) + (_ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide * _ace.currentProject.tileSets[i].tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_x);
	var paletteTilesHigh = (1 + Math.floor(tileCount / _ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide));
	canvasElement.height = (paletteTilesHigh * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom)) + (paletteTilesHigh * _ace.currentProject.tileSets[i].tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_y);
	for(var tileIndex = 0; tileIndex < tileCount; tileIndex++){			
		sourceCutOriginX = tileIndex % _ace.currentProject.tileSets[i].tileCount.INTEGER_tilesWide;
		sourceCutOriginX = sourceCutOriginX * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width + _ace.currentProject.tileSets[i].pixelSpaceBetweenTiles.INTEGER_x) + _ace.currentProject.tileSets[i].pixelStartPosition.INTEGER_x;
		sourceCutOriginY = Math.floor(tileIndex / _ace.currentProject.tileSets[i].tileCount.INTEGER_tilesWide);
		sourceCutOriginY = sourceCutOriginY * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height + _ace.currentProject.tileSets[i].pixelSpaceBetweenTiles.INTEGER_y) + _ace.currentProject.tileSets[i].pixelStartPosition.INTEGER_y;
		sourceCutWidth = _ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom;
		sourceCutHeight = _ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom;
		targetX = tileIndex % _ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide;
		targetX = targetX * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom) + (targetX * _ace.currentProject.tileSets[i].tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_x);
		targetY = Math.floor(tileIndex / _ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide);
		targetY = targetY * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom) + (targetY * _ace.currentProject.tileSets[i].tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_y);
		targetPasteWidth = _ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width;
		targetPasteHeight = _ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height;
		
		if(_ace.currentProject.globalEditorSettings.BOOLEAN_disablePaletteSmoothing){
			canvasContext.imageSmoothingEnabled = false;
			canvasContext.webkitImageSmoothingEnabled = false;
			canvasContext.mozImageSmoothingEnabled = false;
		} else {
			canvasContext.imageSmoothingEnabled = true;
			canvasContext.webkitImageSmoothingEnabled = true;
			canvasContext.mozImageSmoothingEnabled = true;
		}
		
		canvasContext.drawImage(
			tileSetImage,
			sourceCutOriginX,
			sourceCutOriginY,
			targetPasteWidth,
			targetPasteHeight,
			targetX,
			targetY,
			sourceCutWidth,
			sourceCutHeight
		);
	}
	var theTilesetIndex = parseInt(theObjectKey[theObjectKey.length-1], 10);
	var tileX = (_ace.currentProject.globalEditorSettings.INTEGER_selectedTile % _ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide);
	var tileY = Math.floor(_ace.currentProject.globalEditorSettings.INTEGER_selectedTile / _ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_paletteTilesWide);
	if(theTilesetIndex == _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet){
		canvasContext.strokeStyle="#00ff00";
		canvasContext.lineWidth=2;
		canvasContext.rect(
			tileX * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom) + (tileX * _ace.currentProject.tileSets[i].tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_x),
			tileY * (_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom) + (tileY * _ace.currentProject.tileSets[i].tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_y),
			_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom,
			_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height * _ace.currentProject.tileSets[i].tileSetEditorSettings.FLOAT_paletteZoom
		);
		canvasContext.stroke();
	}
}

_ace.preferenceInspector.tilePalette.click = function(theClickedElement, positionWithinElement){
	var theId = $(theClickedElement).parent().parent().parent().attr('id');
	var parentElementId = theId;
	theId = theId.replace("_TilePaletteWindow", "");
	theId = theId.split("-");
	var selectedTileSetIndex = parseInt(theId[theId.length-1],10);
	_ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet = selectedTileSetIndex;
	var tileIndex = 0;
	var tilePosition = {
		x : 0, 
		y: 0
	};
	var tileSetIdentifyer = _ace.preferenceInspector.currentObjectToEdit.ARRAY_useTileSetsWithIdentifyer[selectedTileSetIndex];
	var theTileSet;
	for(i  = 0; i < _ace.currentProject.tileSets.length; i++){
		if(_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == tileSetIdentifyer){
			theTileSet = _ace.currentProject.tileSets[i];
			break;
		}
	}
	tilePosition.x = Math.floor(positionWithinElement.left / ((theTileSet.tilePixelSize.INTEGER_width * theTileSet.tileSetEditorSettings.FLOAT_paletteZoom) + theTileSet.tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_x));
	tilePosition.y = Math.floor(positionWithinElement.top / ((theTileSet.tilePixelSize.INTEGER_height * theTileSet.tileSetEditorSettings.FLOAT_paletteZoom) + theTileSet.tileSetEditorSettings.pixelSpaceBetweenTiles.INTEGER_y));
	tileIndex = tilePosition.y * theTileSet.tileSetEditorSettings.INTEGER_paletteTilesWide + tilePosition.x;
	_ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet = selectedTileSetIndex;
	_ace.currentProject.globalEditorSettings.INTEGER_selectedTile = tileIndex;
	$(".CurrentTileIndex").html("");
	$("#"+parentElementId).find(".CurrentTileIndex").html(", " + tileIndex);
	_ace.preferenceInspector.tilePalette.updateAll();
}

_ace.preferenceInspector.tilePalette.unhideById = function(tilePaletteWindowId){
	$( ".TilePaletteWindow" ).removeClass( "TopTilePaletteWindow" );
	$("#"+tilePaletteWindowId).show();
	$("#"+tilePaletteWindowId).addClass( "TopTilePaletteWindow" );
}

_ace.preferenceInspector.fillTileMapButton = function(){
	_ace.prompt({
		"Fill With Tile (Index)" : ["Use Tile Index", "Current Tile", "Current Air Tile"],
		"Tile Index (String)" : "0, 1, 2"
 	}, 
	"_ace.preferenceInspector.fillTileMap()",
	"Warning! This replaces all tiles in your current layer.");
}

_ace.preferenceInspector.fillTileMap = function(){
	var promptResults = _ace.getPromptResults();
	var tileIndexArray = promptResults.TileIndex;
	tileIndexArray = tileIndexArray.split(",");
	var i;
	var selectedTileSet = _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet;
	var selectedTile = _ace.currentProject.globalEditorSettings.INTEGER_selectedTile;
	var tileSet = _ace.currentProject.tileSets[selectedTileSet];
	var tileSetLength = (tileSet.tileCount.INTEGER_tilesWide * tileSet.tileCount.INTEGER_tilesHigh) ;
	if(promptResults.FillWithTile == 1){
		tileIndexArray = [selectedTile];
	} else if(promptResults.FillWithTile == 2){
		tileIndexArray = [tileSet.tileSetEditorSettings.INTEGER_airTile];
	} else {
		for(i = 0; i < tileIndexArray.length; i++){
			if(isNaN(tileIndexArray[i]) ){
				_ace.prompt({}, "","The list must be an Integer values min 0 max "+(tileSetLength-1)+".");	
				return;
			} else if (tileIndexArray[i] < 0 || tileIndexArray[i] > tileSetLength -1 ){
				_ace.prompt({}, "","The list must be an Integer values min 0 max "+(tileSetLength-1)+".");	
				return;
			}
		}
	}
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	var layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
	var tileObject;
	var currentTileIndex;
	for(i = 0; i < layerObject.map.length; i++){
		currentTileIndex = parseInt(tileIndexArray[parseInt(Math.floor(Math.random() * tileIndexArray.length))]);
		tileObject = {
			INTEGER_tileIndex : currentTileIndex,
			INTEGER_tileSetIndex : _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet,
			STRING_textString: "",
			STRING_tag: ""
		};
		layerObject.map[i] = tileObject;
	}
	_ace.mainView.drawOutputCanvases();
}

_ace.preferenceInspector.addTileSetToLayerButton = function(){
	var listOfTileSetNames = [];
	for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
		listOfTileSetNames.push(_ace.currentProject.tileSets[i].STRING_tileSetName)
	}
	_ace.prompt({
		"Add Tile Set (Index)" : listOfTileSetNames
 	}, 
	"_ace.preferenceInspector.addTileSetToLayer()",
	"Add a tile set to the current layer.");
}

_ace.preferenceInspector.addTileSetToLayer = function(){
	var promptResults = _ace.getPromptResults();
	var tileSetIndex = parseInt(promptResults.AddTileSet);
	var tileSetIdentifier = _ace.currentProject.tileSets[tileSetIndex].STRING_tileSetIdentifyer;
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	_ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex].ARRAY_useTileSetsWithIdentifyer.push(tileSetIdentifier);
	_ace.preferenceInspector.drawCurrentObject();
}

_ace.preferenceInspector.removeTileSetFromLayerButton = function(tileSetIndex){
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	var currentLayer = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
	var listOfTileSetIndexes = [];
	if(currentLayer.ARRAY_useTileSetsWithIdentifyer.length <= 1){
		_ace.prompt({}, "","Layer must have at least 1 tile set.");
		return;
	}
	for(var i = 0; i < currentLayer.ARRAY_useTileSetsWithIdentifyer.length; i++){
		if(i != tileSetIndex){
			listOfTileSetIndexes.push(i);
		}
	}
	_ace.prompt({
		"Replace With Tile Set (List)" : listOfTileSetIndexes,
		"Replace With Tile Index (List)" : ["Keep Index", "Air Tile"]
 	}, 
	"_ace.preferenceInspector.removeTileSetFromLayer("+tileSetIndex+")",
	"Remove tile set "+tileSetIndex+" from the current layer.");
}

_ace.preferenceInspector.removeTileSetFromLayer = function(tileSetIndex){
	var promptResults = _ace.getPromptResults();
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	var currentLayer = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
	var tileSetIndex = parseInt(tileSetIndex, 10);
	var replaceWithTileSetIndex = parseInt(promptResults.ReplaceWithTileSet, 10);
	var tileSetIdentifyer = currentLayer.ARRAY_useTileSetsWithIdentifyer[replaceWithTileSetIndex];
	var theTileSet;
	for(i  = 0; i < _ace.currentProject.tileSets.length; i++){
		if(_ace.currentProject.tileSets[i].STRING_tileSetIdentifyer == tileSetIdentifyer){
			theTileSet = _ace.currentProject.tileSets[i];
			break;
		}
	}
	for(var i = 0; i < currentLayer.map.length; i++){
		if(currentLayer.map[i].INTEGER_tileSetIndex == tileSetIndex){
			currentLayer.map[i].INTEGER_tileSetIndex = replaceWithTileSetIndex;
			switch(promptResults.ReplaceWithTileIndex){
				case "Air Tile": 
					currentLayer.map[i].INTEGER_tileIndex = theTileSet.tileSetEditorSettings.INTEGER_airTile;
				break;
				case "Keep Index":
				
				break;
			}
		}
		if(currentLayer.map[i].INTEGER_tileSetIndex > tileSetIndex){
			currentLayer.map[i].INTEGER_tileSetIndex--;
		}
	}
	_ace.GeneralFunctions.ArrayRemoveAtIndex(currentLayer.ARRAY_useTileSetsWithIdentifyer, tileSetIndex);
	_ace.preferenceInspector.drawCurrentObject();
	_ace.mainView.drawOutputCanvases();
}

// EditLevel

_ace.editCurrentTileMapLayer = {};
_ace.editCurrentTileMapLayer.addRow = function(side){
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	var layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
	switch(side){
		case "top" :
			var emptyRow = _ace.editCurrentTileMapLayer.returnEmptyRow();
			layerObject.mapSize.INTEGER_height ++;
			layerObject.map = emptyRow.concat(layerObject.map);
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
		case "bottom" :
			var emptyRow = _ace.editCurrentTileMapLayer.returnEmptyRow();
			layerObject.mapSize.INTEGER_height ++;
			layerObject.map = layerObject.map.concat(emptyRow);
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
		case "left" :
			
			var selectedTileSet = 0; // _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet;
			var tileSet = _ace.currentProject.tileSets[selectedTileSet];
			var tileObject = {
				INTEGER_tileIndex : tileSet.tileSetEditorSettings.INTEGER_airTile,
				INTEGER_tileSetIndex : selectedTileSet,
				STRING_textString: "",
				STRING_tag: ""
			};
			layerObject.mapSize.INTEGER_width ++;
			for(var i = layerObject.mapSize.INTEGER_height; i>0; i--){
				layerObject.map.splice((layerObject.mapSize.INTEGER_width-1)*(i-1),0,tileObject);
			}
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
		case "right" :
			var selectedTileSet = 0; // _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet;
			var tileSet = _ace.currentProject.tileSets[selectedTileSet];
			var tileObject = {
				INTEGER_tileIndex : tileSet.tileSetEditorSettings.INTEGER_airTile,
				INTEGER_tileSetIndex : selectedTileSet,
				STRING_textString: "",
				STRING_tag: ""
			};
			layerObject.mapSize.INTEGER_width ++;
			for(var i = layerObject.mapSize.INTEGER_height; i>0; i--){
				layerObject.map.splice((layerObject.mapSize.INTEGER_width-1)*i,0,tileObject);
			}
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
	}
}

_ace.editCurrentTileMapLayer.returnEmptyRow = function (){
	var emptyRowArray = [];
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	var layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
	var tempWidth = layerObject.mapSize.INTEGER_width;
	var selectedTileSet = 0; // _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet;
	var tileSet = _ace.currentProject.tileSets[selectedTileSet];
	var tileObject = {
		INTEGER_tileIndex : tileSet.tileSetEditorSettings.INTEGER_airTile,
		INTEGER_tileSetIndex : selectedTileSet,
		STRING_textString: "",
		STRING_tag: ""
	};
	for(var i=0;i<tempWidth;i++){
		emptyRowArray.push(tileObject);
	}
	return emptyRowArray;
}

_ace.editCurrentTileMapLayer.removeRow = function(side){
	var levelIndex = _ace.levelOrganizer.currentlySelected[0];
	var layerIndex = _ace.levelOrganizer.currentlySelected[1];
	var layerObject = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex];
	switch(side){
		case "top" :
			layerObject.mapSize.INTEGER_height --;
			layerObject.map.splice(0, layerObject.mapSize.INTEGER_width);
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
		case "bottom" :
			layerObject.mapSize.INTEGER_height --;
			layerObject.map.splice(layerObject.map.length-layerObject.mapSize.INTEGER_width, layerObject.mapSize.INTEGER_width);
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
		case "left" :
			layerObject.mapSize.INTEGER_width --;
			for(var i = layerObject.mapSize.INTEGER_height; i>0; i--){
				layerObject.map.splice((layerObject.mapSize.INTEGER_width+1)*(i-1),1);
			}
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
		case "right" :
			layerObject.mapSize.INTEGER_width --;
			for(var i = layerObject.mapSize.INTEGER_height; i>0; i--){
				layerObject.map.splice((layerObject.mapSize.INTEGER_width+1)*i-1,1);
			}
			_ace.mainView.drawOutputCanvases();
			_ace.preferenceInspector.updateHtmlFromObject(_ace.preferenceInspector.currentObjectToEdit);
		break;
	}
}
